import time
import speech_recognition as sr
from Adafruit_IO import Client, Feed, Data
import pygame

pygame.mixer.init() # Initialize PyGame

yesResponse = 0
yesSirResponses = []
yesSirResponses.append(pygame.mixer.Sound("yesSir1.wav")) 
yesSirResponses.append(pygame.mixer.Sound("yesSir2.wav")) 
yesSirResponses.append(pygame.mixer.Sound("yesSir3.wav")) 
anythingElseResponse = pygame.mixer.Sound("anythingElse.wav")
veryGoodResponse = pygame.mixer.Sound("veryGood.wav")


# Set to your Adafruit IO key.
# Remember, your key is a secret,
# so make sure not to publish it when you publish this code!
ADAFRUIT_IO_KEY = '5be5de5d0e3c4d7a92c90dc7058fb91e'

# Set to your Adafruit IO username.
# (go to https://accounts.adafruit.com to find your username)
ADAFRUIT_IO_USERNAME = 'robinmitchell1993'

# Create an instance of the REST client.
aio = Client(ADAFRUIT_IO_USERNAME, ADAFRUIT_IO_KEY)


r = sr.Recognizer()

# Names are used for interfacing with the butler
name = ["jeeves", "system"]

# Devices are used as the things we can control
devices = ["lights", "fan", "heater", "computer","chocolate", "tea"]

# Actions are what we can do with devices
actions = ["on", "off", "engage", "disengage", "hot"]


while(1):  
    with sr.Microphone() as source:   
	print("Adjusting...")	
	r.adjust_for_ambient_noise(source, duration =3)
	print("Adjusting done")
	voiceOK = False
	anythingElseResponse.play()

	# Keep running until the voice is understood by Google
	while(voiceOK == False):

		print("Speak:")
		audio = r.listen(source)
		print("Got it .....")

		try:
			speechString = r.recognize_google(audio)
			print(speechString)
			voiceOK = True
		except sr.UnknownValueError:
			print("Could not understand audio")
		except sr.RequestError as e:
			print("Could not request results; {0}".format(e))
				
	# Process the text
	stringSplit = speechString.split(' ')
	deviceList = []
	actionList = []
	butlerActive = False

	for x in range (0, len(stringSplit)):
		
		# Compare string to names
		for y in range(0, len(name)):
			if(stringSplit[x].lower() == name[y].lower()):
				butlerActive = True
				
		# Compare string to devices
		for y in range(0, len(devices)):
			if(stringSplit[x].lower() == devices[y].lower()):
				deviceList.append(devices[y])
		
		# Compare string to actions
		for y in range(0, len(actions)):
			if(stringSplit[x].lower() == actions[y].lower()):
				actionList.append(actions[y])
				
	# Only perform actions if called upon
	if(butlerActive == True):
		# We also make the butler say something at this point
		yesSirResponses[yesResponse].play()
		
		yesResponse += 1
		if(yesResponse > 2):
			yesResponse = 0
		
		# Do actions upon devices
		for x in range(0, len(deviceList)):
			if(deviceList[x] == "chocolate"):
				aio.send("sweetdemand", "1")	
			else:
				aio.send(deviceList[x], actionList[x])	
		
	